;+
; @hidden_file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                              ;
; CHPOINTCOMMA v. 3.1, 11 May 2013.                                            ;
; Jess Maz Apellniz, IAA                                                    ;
;                                                                              ;
; This function changes decimal points by decimal commas.                      ;
;                                                                              ;
; Positional parameters:                                                       ;
; v:      String array wiith the numbers to be substituted.                    ;
;                                                                              ;
; Version history:                                                             ;
; v1.0:   General clean up.                                                    ;
; v2.0:   English version.                                                     ;
; v2.1:   IDLdoc documentation.                                                ;
; v2.5:   Version system update.                                               ;
; v3.0:   Adapted to global changes in SINGLEPLOT and SINGLECONTOUR.           ;
; v3.1:   Only version change.                                                 ;
;                                                                              ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;-
FUNCTION CHPOINTCOMMA, v
ON_ERROR, 1
n       = N_ELEMENTS(v)
FOR i=0,n-1 DO BEGIN
;
; Encontramos la ocurrencia del primer punto. Este debera ser el punto decimal
; que nos interesa. El procedimiento solamente comprueba a continuacin una
; posible excepcin: Que sea un punto del tipo 3.10^4.
;                                              ^
;
 vaux = v[i]
 pos = STRPOS(vaux,'.')
 IF pos GE 0 AND STRMID(vaux,pos-2,3) NE '!9.' THEN STRPUT, vaux, ',', pos
 v[i] = vaux
ENDFOR
RETURN, v

END
