;+
; @hidden_file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                              ;
; JMAPLOTPATH v. 3.1, 11 May 2013.                                             ;
; Jesús Maíz Apellániz, IAA                                                    ;
;                                                                              ;
; This function returns the path where JMAPLOT is located.                     ;
;                                                                              ;
; Positional parameters:                                                       ;
; (none)                                                                       ;
;                                                                              ;
; Keyword parameters:                                                          ;
; JMAPLOT_VERSION: Returns the version.                                        ;
;                                                                              ;
; Version history:                                                             ;
; v3.0:   First version.                                                       ;
; v3.1:   Only version change.                                                 ;
;                                                                              ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;-
FUNCTION JMAPLOTPATH, JMAPLOT_VERSION=jmaplot_version
jmaplot_version = 'v3.1'
jmaplot_path  = FILE_SEARCH(STRSPLIT(!PATH, PATH_SEP(/SEARCH_PATH),/EXTRACT) + '/singleplot.pro')
IF STRLEN(jmaplot_path[0]) EQ 0 THEN STOP, 'JMAPLOT not found in the path'
jmaplot_path = STRMID(jmaplot_path[0],0,STRLEN(jmaplot_path[0])-15)
IF jmaplot_path EQ '' THEN jmaplot_path = './'
IF STRMID(jmaplot_path,STRLEN(jmaplot_path[0])-1,1) NE '/' THEN jmaplot_path = jmaplot_path + '/'
RETURN, jmaplot_path
END
