;+
; @hidden_file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                              ;
; LENGTHV v. 3.1, 11 May 2013.                                                 ;
; Jess Maz Apellniz, IAA                                                    ;
;                                                                              ;
; This function calculates the maximum length of a string array formatted for  ;
;  an axis in order to find out how much space occupies. The dot in exponential;
;  notation is not counted. The sign, decimal marker, and exponent (with       ;
;  possible sign are counted).                                                 ;
;                                                                              ;
; Positional parameters:                                                       ;
; vs:     String array with the text for the ticks.                            ;
;                                                                              ;
; Version history:                                                             ;
; v1.0:   General clean up.                                                    ;
; v2.0:   English version.                                                     ;
; v2.1:   IDLdoc documentation.                                                ;
; v2.5:   Version system update.                                               ;
; v3.0:   Adapted to SINGLEPLOT and SINGLECONTOUR overall changes.             ;
; v3.1:   Only version change.                                                 ;
;                                                                              ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;-
FUNCTION LENGTHV, vs
ON_ERROR, 1
;
; Inicializacin de datos y parmetros
;
n       = N_ELEMENTS(vs)
lengthm = 0
;
; Bucle principal
;
FOR i=0,n-1 DO BEGIN
 lengthi = STRLEN(vs[i])
;
; Caso de potencia de diez positiva
;
 IF STRMID(vs[i],0,4) EQ '10!U' THEN BEGIN
  lengthi = lengthi - 4
  GOTO, JUMP1
 ENDIF
 FOR j=1,4 DO BEGIN
  IF STRMID(vs[i],j,1) EQ '' THEN BEGIN
;
; Caso de notacin exponencial completa (antiguo)
;
   lengthi = lengthi - 7
   GOTO, JUMP1
  ENDIF
  IF STRMID(vs[i],j,3) EQ '!9.' THEN BEGIN
;
; Caso de notacin exponencial completa (antiguo)
;
   lengthi = lengthi - 9
   GOTO, JUMP1
  ENDIF
 ENDFOR
;
; Caso de notacin no cientfica: Simplemente se deja el valor de lengthi
;
 JUMP1: lengthm = lengthm + (lengthi-lengthm)*(lengthi GT lengthm)
ENDFOR
RETURN, lengthm

END
