;+
; @hidden_file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                              ;
; LENGTHV2 v. 3.1, 11 May 2013.                                                ;
; Jess Maz Apellniz, IAA                                                    ;
;                                                                              ;
; This function calculates the length of a simple string variable.             ;
;                                                                              ;
; Positional parameters:                                                       ;
; vs:     Input string.                                                        ;
;                                                                              ;
; Version history:                                                             ;
; v1.0:   General clean up.                                                    ;
; v2.0:   English version.                                                     ;
; v2.1:   IDLdoc documentation.                                                ;
; v2.5:   Version system update.                                               ;
; v3.0:   Adapted to general SINGLEPLOT changes.                               ;
; v3.1:   Only version change.                                                 ;
;                                                                              ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;-
FUNCTION LENGTHV2, vs
ON_ERROR, 1
;
; Inicializacin de datos y parmetros
;
vvs     = vs
n       = N_ELEMENTS(vvs)
length  = STRLEN(vvs)
;
; Bucle principal
;
FOR i=0,n-1 DO BEGIN
 WHILE STRPOS(vvs[i],'!') NE -1 DO BEGIN
  pos = STRPOS(vvs[i],'!')
  IF pos EQ 0           THEN vaux = STRMID(vvs[i],2,length[i]-2) ELSE $
  IF pos EQ length[i]-2 THEN vaux = STRMID(vvs[i],0,length[i]-2) ELSE $
   vaux  = STRMID(vvs[i],0,pos) + STRMID(vvs[i],pos+2,length[i]-pos-2)
  vvs[i] = vaux
  length[i] = length[i] - 2
 ENDWHILE
ENDFOR
RETURN, length
END
