;+
; @hidden_file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                              ;
; LOGTICKSAUX v. 3.1, 11 May 2013.                                             ;
; Jess Maz Apellniz, IAA                                                    ;
;                                                                              ;
; Auxiliary procedure called from TICKS2 to find the 1 to 9 series in each     ;
;  decade. See FTICKS2 to understand the variables.                            ;
;                                                                              ;
; Version history:                                                             ;
; v1.0:   General clean up.                                                    ;
; v2.0:   English version.                                                     ;
; v2.1:   IDLdoc documentation.                                                ;
; v2.5:   Version system update.                                               ;
; v3.0:   Adapted to SINGLEPLOT overall changes.                               ;
; v3.1:   Only version change.                                                 ;
;                                                                              ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;-
PRO LOGTICKSAUX, vmin, vmax, expl, exph, ddl, ddh, vvminaux, vvmaxaux, $
              explalt, exphalt, ddlalt, ddhalt, vvminauxalt, vvmaxauxalt, $
              vvmin, vvmax, vticks, vtickv
ON_ERROR, 1
;                                            Ejemplo si vmin=7.5e3 vmax=1.3e5
expl     = FLOOR(ALOG10(vmin))                             ; expl=3
ddl      = 10^FLOAT(expl)                                  ; ddl=1e3
vvminaux = CEIL(vmin/ddl)                                  ; vvminaux=8
;
; En caso de que vvminaux sea 10, se le hace 1 y se carga en las variables
; alternativas el valor 10
;
explalt = expl & ddlalt = ddl & vvminauxalt = vvminaux
IF vvminaux EQ 10 THEN BEGIN
 expl = expl+1 & ddl = 10*ddl & vvminaux = 1
ENDIF
vvmin    = vvminaux*ddl                                    ; vvmin=8e3
exph     = FLOOR(ALOG10(vmax))                             ; exph=5
ddh      = 10^FLOAT(exph)                                  ; ddh=1e5
vvmaxaux = FLOOR(vmax/ddh)                                 ; vvmaxaux=1
exphalt = exph & ddhalt = ddh & vvmaxauxalt = vvmaxaux
;
; En caso de que vvmaxaux sea 10, se deja as y se carga en las variables
; alternativas el valor 1
;
IF vvmaxaux EQ 1 THEN BEGIN
 exphalt = exph-1 & ddhalt = ddh/10 & vvmaxauxalt = 10
ENDIF
vvmax    = vvmaxaux*ddh                                    ; vvmax=1e5
vticks   = (10-vvminaux)+(vvmaxaux)+9*(exph-expl-1)-1      ; =2+1+9-1=12
IF expl EQ exph THEN BEGIN
 vtickv[0:vticks] = ddl*(vvminaux+FINDGEN(vticks+1))
ENDIF ELSE BEGIN
 vtickv[0:9-vvminaux] = ddl*(vvminaux+FINDGEN(10-vvminaux))
 FOR i=expl+1,exph-1 DO BEGIN
  vtickv[10-vvminaux+(i-expl-1)*9:18-vvminaux+(i-expl-1)*9] = $
   10^FLOAT(i)*(1+FINDGEN(9))
 ENDFOR
 vtickv[vticks-vvmaxaux+1:vticks] = ddh*(1+FINDGEN(vvmaxaux))
ENDELSE

END
