;+
; @hidden_file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                              ;
; OPENHTML v. 3.1, 11 May 2013.                                                ;
; Jess Maz Apellniz, IAA                                                    ;
;                                                                              ;
; This procedure opens an HTML file in its corresponding browser.              ;
;                                                                              ;
; Positional parameters:                                                       ;
; url:      URL to open.                                                       ;
;                                                                              ;
; Version history:                                                             ;
; v2.2:   First version.                                                       ;
; v2.5:   Version system update.                                               ;
; v3.0:   Adapted to SINGLEPLOT and SINGLECONTOUR overall changes.             ;
; v3.1:   Only version change.                                                 ;
;                                                                              ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;-
PRO OPENHTML, url
ON_ERROR, 1
tags = TAG_NAMES(!VERSION)
pos  = WHERE(tags EQ 'OS_NAME', npos)
IF npos EQ 1 THEN BEGIN
 IF !VERSION.OS_NAME EQ 'Mac OS X' THEN BEGIN
  SPAWN, 'open -a Safari ' + url, /SH
  RETURN
 ENDIF
ENDIF
IF !VERSION.OS_FAMILY EQ 'unix' THEN BEGIN
 SPAWN, 'which netscape', result, /SH
 pos = STRPOS(result,'Command not Found')
 IF pos[0] EQ -1 THEN BEGIN
  SPAWN, 'netscape ' + url + ' &', /SH
 ENDIF ELSE BEGIN
  PRINT, 'You have attempted to open the web page'
  PRINT, url
  PRINT, 'but you do not seem to have netscape installed'
 ENDELSE
ENDIF ELSE IF !VERSION.OS_FAMILY EQ 'Windows' THEN BEGIN
 PUSHD, 'C:\Program Files\Internet Explorer'
 SPAWN, 'IEXPLORE ' + url, /SH
 POPD
ENDIF ELSE BEGIN
 PRINT, 'You have attempted to open the web page'
 PRINT, url
 PRINT, 'from an operating system I do not recognize'
 PRINT, 'Please, send me an e-mail to jmaiz at iaa.es'
 PRINT, 'with this output'
 HELP, !version, /str
ENDELSE
END

