;+
; @hidden_file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                              ;
; STRALLPOS v. 3.1, 11 May 2013.                                               ;
; Jess Maz Apellniz, IAA                                                    ;
;                                                                              ;
; This procedure finds all the instances of search in string.                  ;
;                                                                              ;
; Positional parameters:                                                       ;
; string: Input string.                                                        ;
; search: Expression to search.                                                ;
;                                                                              ;
; Keyword parameters:                                                          ;
; COUNT:  Number of ocurrences.                                                ;
;                                                                              ;
; Version history:                                                             ;
; v1.0:   General clean up.                                                    ;
; v2.0:   English version.                                                     ;
; v2.1:   IDLdoc documentation.                                                ;
; v2.5:   Version system update.                                               ;
; v3.0:   Adapted to SINGLEPLOT and SINGLECONTOUR overall changes.             ;
; v3.1:   COUNT added.                                                         ;
;                                                                              ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;-
FUNCTION STRALLPOS, string, search, COUNT=count
ON_ERROR, 1
pos0  = STRPOS(string, search)
count = 0
IF pos0 EQ -1 THEN RETURN, [-1]
aux   = 'kk'
WHILE pos0 NE -1 DO BEGIN
 IF aux EQ 'kk' THEN pos = [pos0] ELSE pos  = [pos,pos0]
 aux  = ''
 pos0 = STRPOS(string,search,pos[N_ELEMENTS(pos)-1]+1)
ENDWHILE
count = N_ELEMENTS(pos)
RETURN, pos
END
