;+
; WRITEDATA writes data files with up to 50 columns.                      
; See the <a HREF="../writedata.pro">full procedure</a><BR>
; @examples <PRE>
;  WRITEDATA can be used as: 
;    WRITEDATA, 'test.dat', a, b, c, d                              ; Unformatted data
;    WRITEDATA, 'test.dat', a, b, c, d, FORMAT='(2(D16.6,X),I5,A6)' ; Full format data </PRE>
; @version v. 3.1, 11 May 2013.                                              <BR>
; @history <PRE>                                                        
;
;  v1.0: First version.                                                   
;  v1.1: LASTLINES is added.                                              
;  v2.0: English version.                                                 
;  v2.1: IDLdoc documentation.
;  v2.2: OPENHTML introduced.
;        Upgrade to IDLdoc documentation.
;  v2.4: Bug fixed when one array is made up of zeros. 
;  v2.5: Version system update. 
;  v3.0: Complete reprogramming.  
;        HTML pages moved to local directory.
;        Number of variables increased to 82. 
;  v3.1: Only version change. </PRE>
; @author Jess Maz Apellniz, IAA   <BR>
; @param   file {in}{required}{type=string} File name.                                                        <BR>
; @param   v1 {in}{required} First variable to be written.                                     <BR>
; @param   v2 {in}{optional} Additional variable to be written.                 <BR>
; @param   v3 {in}{optional} Additional variable to be written.                 <BR>
; @param   v4 {in}{optional} Additional variable to be written.                 <BR>
; @param   v5 {in}{optional} Additional variable to be written.                 <BR>
; @param   v6 {in}{optional} Additional variable to be written.                 <BR>
; @param   v7 {in}{optional} Additional variable to be written.                 <BR>
; @param   v8 {in}{optional} Additional variable to be written.                <BR>
; @param   v9 {in}{optional} Additional variable to be written.                 <BR>
; @param   v10 {in}{optional} Additional variable to be written.                <BR>
; @param   v11 {in}{optional} Additional variable to be written.                <BR>
; @param   v12 {in}{optional} Additional variable to be written.                <BR>
; @param   v13 {in}{optional} Additional variable to be written.                <BR>
; @param   v14 {in}{optional} Additional variable to be written.                <BR>
; @param   v15 {in}{optional} Additional variable to be written.                <BR>
; @param   v16 {in}{optional} Additional variable to be written.                <BR>
; @param   v17 {in}{optional} Additional variable to be written.                <BR>
; @param   v18 {in}{optional} Additional variable to be written.                <BR>
; @param   v19 {in}{optional} Additional variable to be written.                <BR>
; @param   v20 {in}{optional} Additional variable to be written.                <BR>
; @param   v21 {in}{optional} Additional variable to be written.                <BR>
; @param   v22 {in}{optional} Additional variable to be written.                <BR>
; @param   v23 {in}{optional} Additional variable to be written.                <BR>
; @param   v24 {in}{optional} Additional variable to be written.                <BR>
; @param   v25 {in}{optional} Additional variable to be written.                <BR>
; @param   v26 {in}{optional} Additional variable to be written.                <BR>
; @param   v27 {in}{optional} Additional variable to be written.                <BR>
; @param   v28 {in}{optional} Additional variable to be written.                <BR>
; @param   v29 {in}{optional} Additional variable to be written.                <BR>
; @param   v30 {in}{optional} Additional variable to be written.                <BR>
; @param   v31 {in}{optional} Additional variable to be written.                <BR>
; @param   v32 {in}{optional} Additional variable to be written.                <BR>
; @param   v33 {in}{optional} Additional variable to be written.                <BR>
; @param   v34 {in}{optional} Additional variable to be written.                <BR>
; @param   v35 {in}{optional} Additional variable to be written.                <BR>
; @param   v36 {in}{optional} Additional variable to be written.                <BR>
; @param   v37 {in}{optional} Additional variable to be written.                <BR>
; @param   v38 {in}{optional} Additional variable to be written.                <BR>
; @param   v39 {in}{optional} Additional variable to be written.                <BR>
; @param   v40 {in}{optional} Additional variable to be written.                <BR>
; @param   v41 {in}{optional} Additional variable to be written.                <BR>
; @param   v42 {in}{optional} Additional variable to be written.                <BR>
; @param   v43 {in}{optional} Additional variable to be written.                <BR>
; @param   v44 {in}{optional} Additional variable to be written.                <BR>
; @param   v45 {in}{optional} Additional variable to be written.                <BR>
; @param   v46 {in}{optional} Additional variable to be written.                <BR>
; @param   v47 {in}{optional} Additional variable to be written.                <BR>
; @param   v48 {in}{optional} Additional variable to be written.                <BR>
; @param   v49 {in}{optional} Additional variable to be written.                <BR>
; @param   v50 {in}{optional} Additional variable to be written.                <BR>
; @param   v51 {in}{optional} Additional variable to be written.                <BR>
; @param   v52 {in}{optional} Additional variable to be written.                <BR>
; @param   v53 {in}{optional} Additional variable to be written.                <BR>
; @param   v54 {in}{optional} Additional variable to be written.                <BR>
; @param   v55 {in}{optional} Additional variable to be written.                <BR>
; @param   v56 {in}{optional} Additional variable to be written.                <BR>
; @param   v57 {in}{optional} Additional variable to be written.                <BR>
; @param   v58 {in}{optional} Additional variable to be written.                <BR>
; @param   v59 {in}{optional} Additional variable to be written.                <BR>
; @param   v60 {in}{optional} Additional variable to be written.                <BR>
; @param   v61 {in}{optional} Additional variable to be written.                <BR>
; @param   v62 {in}{optional} Additional variable to be written.                <BR>
; @param   v63 {in}{optional} Additional variable to be written.                <BR>
; @param   v64 {in}{optional} Additional variable to be written.                <BR>
; @param   v65 {in}{optional} Additional variable to be written.                <BR>
; @param   v66 {in}{optional} Additional variable to be written.                <BR>
; @param   v67 {in}{optional} Additional variable to be written.                <BR>
; @param   v68 {in}{optional} Additional variable to be written.                <BR>
; @param   v69 {in}{optional} Additional variable to be written.                <BR>
; @param   v70 {in}{optional} Additional variable to be written.                <BR>
; @param   v71 {in}{optional} Additional variable to be written.                <BR>
; @param   v72 {in}{optional} Additional variable to be written.                <BR>
; @param   v73 {in}{optional} Additional variable to be written.                <BR>
; @param   v74 {in}{optional} Additional variable to be written.                <BR>
; @param   v75 {in}{optional} Additional variable to be written.                <BR>
; @param   v76 {in}{optional} Additional variable to be written.                <BR>
; @param   v77 {in}{optional} Additional variable to be written.                <BR>
; @param   v78 {in}{optional} Additional variable to be written.                <BR>
; @param   v79 {in}{optional} Additional variable to be written.                <BR>
; @param   v80 {in}{optional} Additional variable to be written.                <BR>
; @param   v81 {in}{optional} Additional variable to be written.                <BR>
; @param   v82 {in}{optional} Additional variable to be written.                <BR>
; @keyword FORMAT {in}{optional}{type=string} Format.<BR>
; @keyword FIRSTLINES {in}{optional}{type=string array} Lines to be written at 
;           the beginning of the file.<BR>
; @keyword LASTLINES {in}{optional}{type=string array} Lines to be written at 
;           the end of the file.<BR>
;-
;<PRE>
PRO WRITEDATA, file, v1,  v2,  v3,  v4,  v5,  v6,  v7,  v8,  v9, v10, $
                    v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, $
                    v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, $
                    v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, $
                    v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, $
                    v51, v52, v53, v54, v55, v56, v57, v58, v59, v60, $
                    v61, v62, v63, v64, v65, v66, v67, v68, v69, v70, $
                    v71, v72, v73, v74, v75, v76, v77, v78, v79, v80, $
                    v81, v82, $
 		    FORMAT=format, FIRSTLINES=firstlines, LASTLINES=lastlines
ON_ERROR, 2
ncomp = N_PARAMS() - 1
IF ncomp LE 0 THEN BEGIN
 jmaplot_path = JMAPLOTPATH(JMAPLOT_VERSION=jmaplot_version)
 OPENHTML, jmaplot_path + 'html/writedata.html'
 RETURN
ENDIF
IF ncomp LE 0 THEN MESSAGE, 'At least one vector is needed'
OPENW, unit, file, /GET_LUN, ERROR=err
IF KEYWORD_SET(FIRSTLINES) THEN FOR i=0,N_ELEMENTS(firstlines)-1 DO PRINTF, unit, firstlines[i]
IF KEYWORD_SET(FORMAT) EQ 0 THEN format = ''
str = ' PRINTF, unit,'
FOR j=0,ncomp-1 DO str = str + ' v' + STRTRIM(j+1,2) + '[i],'
str = str + 'FORMAT=format'
FOR i=0L,N_ELEMENTS(v1)-1 DO tmp = EXECUTE(str)
IF KEYWORD_SET(LASTLINES)  THEN FOR i=0,N_ELEMENTS(lastlines)-1  DO PRINTF, unit,  lastlines[i]
CLOSE, unit
FREE_LUN, unit
END
;</PRE>
